//
//  PKUtils.m
//  Liquid Author
//
//  Created by Tmi Parabits on 18.8.2013.
//  Copyright (c) 2013 SoftCubicle. All rights reserved.
//

#import "PKUtils.h"
#import <QuartzCore/QuartzCore.h>

@implementation PKUtils

+(void)showLayer:(CALayer*)theLayer
{
    if (theLayer.animationKeys!=nil||theLayer.opacity==1.0)return;
    
    
    CABasicAnimation* fadeAnim = [CABasicAnimation animationWithKeyPath:@"opacity"];
    fadeAnim.fromValue = [NSNumber numberWithFloat:0.0];
    fadeAnim.toValue = [NSNumber numberWithFloat:1.0];
    fadeAnim.duration = 0.5;
    fadeAnim.removedOnCompletion=YES;
    
    [theLayer addAnimation:fadeAnim forKey:@"opacity"];
    
    // Change the actual data value in the layer to the final value.
    theLayer.opacity = 1.0;
}

+(void)hideLayer:(CALayer*)theLayer
{
    if (theLayer.animationKeys!=nil||theLayer.opacity==0.0)return;
    
    CABasicAnimation* fadeAnim = [CABasicAnimation animationWithKeyPath:@"opacity"];
    fadeAnim.fromValue = [NSNumber numberWithFloat:1.0];
    fadeAnim.toValue = [NSNumber numberWithFloat:0.0];
    fadeAnim.duration = 1.0;
    [theLayer addAnimation:fadeAnim forKey:@"opacity"];
    fadeAnim.removedOnCompletion=YES;
    
    // Change the actual data value in the layer to the final value.
    theLayer.opacity = 0.0;
}
@end
