//
//  PKWebView.m
//  Liquid Author
//
//  Created by Tmi Parabits on 7.8.2013.
//  Copyright (c) 2013 SoftCubicle. All rights reserved.
//

#import "PKWebView.h"
#import "PKViewController.h"

#import "PKClippingsView.h"

@interface PKWebView() {
    
}

@end

@implementation PKWebView

-(void)mouseMoved:(NSEvent *)theEvent
{
    NSPoint location=theEvent.locationInWindow;
    
    if (location.x<150 || location.x>self.bounds.size.width-150) {
        [self.controller clippingViewVisible:YES];
    } else {
        [self.controller clippingViewVisible:NO];
    }
    
    
}

/*
 
 #pragma mark Dragging destination methods

-(BOOL)wantsPeriodicDraggingUpdates {
    return NO;
}
*/

/*
-(NSDragOperation)draggingUpdated:(id<NSDraggingInfo>)sender
{
    NSPoint point=sender.draggingLocation;
    
   // NSLog(@"2) Dragging updated.");
   // NSLog(@"Drag location: (%f, %f)", point.x, point.y);
    */
    /*if (point.x<150 || point.x>self.frame.size.width-150) {
        
        [sender enumerateDraggingItemsWithOptions:NSDraggingItemEnumerationClearNonenumeratedImages forView:self classes:@[[NSString class]] searchOptions:nil usingBlock:^(NSDraggingItem *draggingItem, NSInteger idx, BOOL *stop) {
            
            draggingItem.imageComponentsProvider = ^ {
                
                return [self getImageComponents];
            };
        }];
    }*/
    /*
    return NSDragOperationEvery;
}

-(void)updateDraggingItemsForDrag:(id<NSDraggingInfo>)sender
{
    NSPoint point=sender.draggingLocation;
    
    NSLog(@"3) Dragging updating dragging items for drag.");
    NSLog(@"Drag location: (%f, %f)", point.x, point.y);
    
    if (point.x<150 || point.x>self.frame.size.width-150) {
        
        [sender enumerateDraggingItemsWithOptions:NSDraggingItemEnumerationClearNonenumeratedImages forView:self classes:@[[NSString class]] searchOptions:nil usingBlock:^(NSDraggingItem *draggingItem, NSInteger idx, BOOL *stop) {
            
            draggingItem.imageComponentsProvider = ^ {
                
                return [self getImageComponents];
            };
        }];
    }
}

- (void)draggingEnded:(id < NSDraggingInfo >)sender
{
    NSPoint point=sender.draggingLocation;
    NSImage* image=sender.draggedImage;
    
    if (point.x<150 || point.x>self.frame.size.width-150) {
        
        NSLog(@"Drop location: (%f, %f)", point.x, point.y);
        
        CGRect rect=CGRectMake(0, 0, image.size.width, image.size.height);
        NSImageView *imageView=[[NSImageView alloc]initWithFrame:rect];
        imageView.image=[self destinationDragImage];
        
        [self.controller addClipping:point text:@"hello world"];
    }
    
    NSLog(@"4) Dragging done.");
}
*/

/*-(NSDragOperation)draggingEntered:(id<NSDraggingInfo>)sender
{
    NSPasteboard *pasteboard=sender.draggingPasteboard;
    
    
    for (NSPasteboardItem *p in pasteboard.pasteboardItems) {
        for (NSString *type in p.types) {
            NSLog(@"%@", type);
        }
    }
    
    return NSDragOperationEvery;
}*/
-(NSString*)className
{
    return @"PKWebView";
}

-(BOOL)prepareForDragOperation:(id<NSDraggingInfo>)sender
{
    
    if ([sender draggingSource] == nil)
    {
        NSPasteboard *pboard = [sender draggingPasteboard];
        
        if ( [[pboard types] containsObject:NSFilenamesPboardType] ) {
            
            NSString *fileURL=[[NSURL URLFromPasteboard: [sender draggingPasteboard]]relativePath];
            
            NSLog(@"Dragged image:%@", fileURL);
            NSString *markup;
            
            if ([fileURL rangeOfString:@".png"].location==NSNotFound||[fileURL rangeOfString:@".jpg"].location==NSNotFound) return NO;
            
            markup=[NSString stringWithFormat:@"<img src='%@'>", fileURL];
            
            [self replaceSelectionWithMarkupString:markup];
        }
        return YES;

    } else if ([[sender draggingSource]isKindOfClass:[PKClippingsView class]]) {
        return YES;
    }
    
    return YES;
}


/*


-(BOOL)locationInDocument:(NSPoint)point
{
    return (point.x<150 || point.x>self.frame.size.width-150);
}

-(NSArray*)getImageComponents
{
    NSDraggingImageComponent *imageComponent;
    NSMutableArray *components = [NSMutableArray arrayWithCapacity:1];
    
    NSImage *destination=[self destinationDragImage];
    
    imageComponent = [NSDraggingImageComponent draggingImageComponentWithKey:NSDraggingImageComponentIconKey];
    imageComponent.frame = CGRectMake(0, 0, destination.size.width, destination.size.height);
    imageComponent.contents = destination;
    [components addObject:imageComponent];
    
    return components;
}

-(NSImage*)destinationDragImage
{
    //image to draw into
    NSImage *returnValue = [[NSImage alloc] initWithSize:NSMakeSize(200.0,  30.0)];
    
    NSString *snippetText=@"Hello world.";
    
    NSPoint textLocation = NSMakePoint(0,0);
    NSShadow *textShadow = [[NSShadow alloc] init];
    [textShadow setShadowOffset:NSMakeSize(0,0)];
    [textShadow setShadowColor:[NSColor clearColor]];
    [textShadow setShadowBlurRadius:0];
    
    NSMutableDictionary *textAttributes =
    [NSMutableDictionary dictionaryWithObjectsAndKeys:
     [NSFont fontWithName:@"Georgia" size:15], NSFontAttributeName,
     [NSColor blackColor], NSForegroundColorAttributeName,
     textShadow, NSShadowAttributeName,
     nil];
    
    // find the optimal size
    CGFloat fontSize;
    NSSize testSize = NSMakeSize(0, 0);
    
    for(fontSize=1; testSize.width < [returnValue size].width; fontSize*=2)
    {
        [textAttributes setObject:[NSFont fontWithName:@"Georgia"
                                                  size:fontSize]
                           forKey:NSFontAttributeName];
        testSize = [snippetText sizeWithAttributes:textAttributes];
    }
    
    if (fontSize>24)fontSize=24;
    
    [textAttributes setObject:[NSFont fontWithName:@"Georgia"
                                              size:fontSize/2]
                       forKey:NSFontAttributeName];
    
    // and draw the text
    [returnValue lockFocus];
    
    [snippetText drawAtPoint:textLocation
              withAttributes:textAttributes];
    
    NSBezierPath *path=[NSBezierPath bezierPathWithRect:CGRectMake(0, 0, returnValue.size.width, returnValue.size.height)];
    [[NSColor blackColor]set];
    
    [path stroke];
    
    [returnValue unlockFocus];
    
    return returnValue;
}*/



@end
